pro clipspectra, filestr, minwav=minwav, maxwav=maxwav

  ; deal with a bad flux calibration by removing points outside a certain wavelength range

  files = file_search(filestr)
  files = files[sort(files)]

  if n_elements(minwav) eq 0 then minwav = 0.
  if n_elements(maxwav) eq 0 then maxwav = 1e20

  for f = 0, n_elements(files)-1 do begin
     sp = readspec(files[f], h)
     n = n_elements(sp)
     w = where(sp.wav gt minwav and sp.wav lt maxwav, ct) ; region to KEEP
     if ct eq 0 then begin
        print, files[f]+': all of spectrum would be clipped'
        continue
     endif
     if ct eq n then begin
        print, files[f]+': nothing to clip'
        continue
     endif
     sp = sp[w]
     print, files[f]+': removed '+clip(n-ct)+' points (out of '+clip(n)+')'
     sxaddpar, h, 'SPECCLIP', clip(minwav)+'-'+clip(maxwav)
     writespec, files[f], sp, h
  endfor


end

