pro distortionpoly4, dx, dy, par, ra, dec
 
 ; Distortion polynomial of 4th (easily modified to arbitrary) order

 ; x is the pixel offset from center along the x axis (u in SIP PDF)
 ; y is the pixel offset from center along the y axis

 ; return values are ra and dec  (not offsets, doing the tan "projection" myself loosely)

CRVAL1 = par[0]
CRVAL2 = par[1]
cost = cos(par[2]*!pi/180.)
sint = sin(par[2]*!pi/180.)
iCD11 = par[3] 
iCD12 = par[4] 
iCD21 = par[5] 
iCD22 = par[6] 

CD11 = cost*iCD11+sint*iCD21
CD12 = cost*iCD12+sint*iCD22
CD21 =-sint*iCD11+cost*iCD21
CD22 =-sint*iCD12+cost*iCD22



order = 4 ; could measure from size of par array

A = dblarr(order+1,order+1)
B = dblarr(order+1,order+1)

p = 7
for ab = 0, 1 do begin
  o = 2  ; start with [2,0] since lower orders are zero always
  i = o
  j = 0
  while o le order do begin
    if ab eq 0 then A[i,j] = par[p]
    if ab eq 1 then B[i,j] = par[p]
    i -= 1
    j += 1
    if i lt 0 then begin
       j = 0
       o += 1
       i = o
    endif 
    p += 1
  endwhile
endfor

dxi = 0.
dyi = 0.
for i = 0, order do begin
for j = 0, order-i do begin
   pp = dx^i * dy^j  ; not optimized
   dxi += A[i,j]*pp
   dyi += B[i,j]*pp
endfor
endfor

ra  = CRVAL1 + (CD11*(dx+dxi)+CD12*(dy+dyi))/cos(!pi*CRVAL2/180.)
dec = CRVAL2 +  CD21*(dx+dxi)+CD22*(dy+dyi) 

end

