;+
; NAME: mag2ujy.pro
;
; PURPOSE: 
;       Convert a magnitude to a flux density in microJy.
;
; CALLING SEQUENCE: 
;       mag2ujy, mag, filter
;
; INPUTS:
;       mag    = Magnitude (must be Pogson/logarithmic magnitude).  Can be vector.
;       filter = Standard filter string, or AB.  Can be vector.
;
; OPTIONAL INPUT KEYWORD PARAMETERS: none
;
; OPTIONAL OUTPUT KEYWORD PARAMETERS: none
; 
; OUTPUTS: The flux density in microJy
;
; REQUIREMENTS: none
;
; Last modified 27 Jun 2018.  Documentation added 2022.
;-

function mag2ujy, mag, filter

  ;units of microJy

  return, 10.0^(zeropt(filter)-mag/2.5)

end

