;+
; NAME: 
;   nndist
;
; PURPOSE: 
;   Based on a list of coordinates, calculate the distance to the nearest neighbor for
;   each object in the list.    
;
; CALLING SEQUENCE: 
;   dist = nndist(x, y)
;       
; INPUTS:
;   x, y - Coordinate arrays       
;
; OUTPUTS:
;   dist - Array containing the distance to the nearest object to each member of the list
;
; LPipe usage: fieldphot
;
; Last modified 2 Apr  2012.  Documentation added 3 July 2022.
;-

function nndist, x, y
   allmindist = fltarr(n_elements(x))
   for i = 0L, n_elements(x)-1 do begin
      mindist = 1e9
      for j = 0, n_elements(x)-1 do begin
         if i eq j then continue
         dist = sqrt((x[i]-x[j])^2+(y[i]-y[j])^2)
         if dist lt mindist then mindist = dist
      endfor
      allmindist[i] = mindist
   endfor
   return, allmindist
end

